//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A8C3FD4030A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A8C3FD4030A.cm

//## begin module%3A8C3FD4030A.cp preserve=no
//## end module%3A8C3FD4030A.cp

//## Module: CGroupBase%3A8C3FD4030A; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/CGroupBase.h

#ifndef CGROUPBASE_H
#define CGROUPBASE_H 1

//## begin module%3A8C3FD4030A.additionalIncludes preserve=no
//## end module%3A8C3FD4030A.additionalIncludes

//## begin module%3A8C3FD4030A.includes preserve=yes
//## end module%3A8C3FD4030A.includes

// Reference
#include <XSUtil/Utils/Reference.h>
// ModelBase
#include <XSModel/Model/ModelBase.h>
// ComponentListTypes
#include <XSModel/Model/Component/ComponentListTypes.h>

class SumComponent;
class Component;
class Parameter;

//## begin module%3A8C3FD4030A.declarations preserve=no
//## end module%3A8C3FD4030A.declarations

//## begin module%3A8C3FD4030A.additionalDeclarations preserve=yes
class ComponentGroup;
class UniqueEnergy;

template <typename T> class ModelExpression;
class ModExprTreeMember;
//## end module%3A8C3FD4030A.additionalDeclarations


//## begin CGroupBase%3A8C3E710351.preface preserve=yes
//## end CGroupBase%3A8C3E710351.preface

//## Class: CGroupBase%3A8C3E710351
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A8C4C52005C;RefCounter { -> }
//## Uses: <unnamed>%3A8D4F3000EC;ComponentCreator { -> }
//## Uses: <unnamed>%3AA92F1C030E;Parameter { -> F}

class CGroupBase 
{
  //## begin CGroupBase%3A8C3E710351.initialDeclarations preserve=yes
  //## end CGroupBase%3A8C3E710351.initialDeclarations

  public:
    //## Constructors (generated)
      CGroupBase(const CGroupBase &right);

    //## Constructors (specified)
      //## Operation: CGroupBase%3A8C4219030D
      CGroupBase (ModelExpression<ModExprTreeMember>& gs, ModelBase* p, bool nest = false);

    //## Destructor (generated)
      ~CGroupBase();

    //## Assignment Operation (generated)
      CGroupBase & operator=(const CGroupBase &right);


    //## Other Operations (specified)
      //## Operation: resetComponentFlux%3CB5F10F019D
      void resetComponentFlux ();

      //## Operation: getVariableParameters%3C7BA4EB0009
      std::vector<ModParam*> getVariableParameters () const;

      //## Operation: parentName%3A8D3EB9010E
      const string& parentName () const;

      //## Operation: clone%3A8D48BE001D
      CGroupBase* clone () const;

      //## Operation: setElement%3A8D4E7A0398;      C++
      void setElement (XSModExpTree<ComponentGroup*>& componentGroups);

      //## Operation: dataGroup%3A9E94BA03BA
      size_t dataGroup () const;

      //## Operation: registerParameters%3A9EA5690237
      void registerParameters () const;

      //## Operation: parameterIndexBase%3AA3FB9500DE
      size_t parameterIndexBase () const;

      //## Operation: incrementModelParameterCount%3AA558DF029E
      //	Add one to component count and paramIncrement to
      //	parameter count for the containing model.
      size_t incrementModelParameterCount ();

      //## Operation: incrementModelComponentCount%3AA558EE01B3
      //	Add one to component count and paramIncrement to
      //	parameter count for the containing model.
      size_t incrementModelComponentCount ();

      //## Operation: modelIndex%3AA696D10102
      size_t modelIndex () const;

      //## Operation: getLocalParameter%3AA92D1A0282
      Parameter* getLocalParameter (size_t i) const;

      //## Operation: localParameter%3AA93759014C
      Parameter* localParameter (size_t i) const;

      //## Operation: setElements%3AB672DF00DA
      void setElements (const string& componentName, const Component* newElement);

      //## Operation: calculate%3AC8C3F002BC
      void calculate (bool saveComponentFlux = false, bool frozen = false);

      //## Operation: energyArray%3AD322C800E5
      const ArrayContainer& energyArray () const;

      //## Operation: setComputeFlag%3C20ECE700D3
      void setComputeFlag (bool value);

      //## Operation: normParams%3C6D2FF6009F
      std::list<ModParam*> normParams () const;

      //## Operation: clearArrays%3C7670B103B8
      void clearArrays (const std::set<UniqueEnergy*>& currentEngs);

      //## Operation: checkNorms%3C8915D502FC
      void checkNorms (IntegerArray& paramsToFreeze) const;

      //## Operation: saveComponentFlux%3CB71C2400F1
      void saveComponentFlux (bool setSaveFlux = false);

      //## Operation: combine%3D08C0FA00FE
      void combine ();

      //## Operation: sources%3DE7AD280095
      std::list<SumComponent*> sources ();

      //## Operation: modelComponentCount%3EE0D654024A
      //	Add one to component count and paramIncrement to
      //	parameter count for the containing model.
      size_t modelComponentCount ();

      //## Operation: modelParameterCount%3EE0D6710320
      //	Add one to component count and paramIncrement to
      //	parameter count for the containing model.
      size_t modelParameterCount ();

      //## Operation: deleteComponent%3EF9EC15034F
      void deleteComponent (int sequenceNumber, int index);

      //## Operation: setNestedElement%3F01F46C024D
      void setNestedElement (const string& componentName, Component* newElement);

      //## Operation: resetElement%3F1EBC0302E5
      void resetElement (XSModExpTree<ComponentGroup*>& newGroups, const std::vector<Component*>& existingComponents);

      //## Operation: element%3F1ECCDE0327
      Component* element (int index) const;

      //## Operation: insertComponent%3F26BBE2031B
      void insertComponent (int location, int index, const string& name, char op);

      //## Operation: exchangeComponent%45129B1B03BE
      void exchangeComponent (int location, Component* newComponent);

      //## Operation: createComponent%4512D8BA0328
      Component* createComponent (string& name);

      //## Operation: deregisterParameters%3F297F040034
      void deregisterParameters () const;

      //## Operation: firstComponent%3F72045B00D1
      Component* firstComponent ();

      //## Operation: resizeElements%405B62F6017A
      void resizeElements (size_t n);

      //## Operation: addToElements%4134D20403B7
      void addToElements (int componentOffset, Component* newComponent);

      //## Operation: uniqueEnergyArray%43D64D510301
      const std::set<UniqueEnergy*>& uniqueEnergyArray () const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: nested%3AF0551603D5
      const bool nested () const;
      void nested (bool value);

      //## Attribute: componentInfo%484E9B79019B
      ModelExpression<ModExprTreeMember>* componentInfo ();
      void componentInfo (ModelExpression<ModExprTreeMember>* value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::<unnamed>%3A8C40B900BC
      //## Role: CGroupBase::groupFlux%3A8C40B9028D
      SumComponent* groupFlux ();
      void groupFlux (SumComponent* value);

      //## Association: XSModel::Model::Component::<unnamed>%3A8D3ED102AA
      //## Role: CGroupBase::parent%3A8D3ED6019A
      const ModelBase* parent () const;
      void parent (ModelBase* value);

      //## Association: XSModel::Model::Component::<unnamed>%3AB668D80201
      //## Role: CGroupBase::elements%3AB668D80229
      const ComponentList& elements () const;
      void elements (const ComponentList& value);

    // Additional Public Declarations
      //## begin CGroupBase%3A8C3E710351.public preserve=yes
      //## end CGroupBase%3A8C3E710351.public

  protected:
    // Additional Protected Declarations
      //## begin CGroupBase%3A8C3E710351.protected preserve=yes
      //## end CGroupBase%3A8C3E710351.protected

  private:

    //## Other Operations (specified)
      //## Operation: swap%3A8C3F8A0352
      void swap (CGroupBase& right);

      //## Operation: parenSum%3AE71AB7000C
      SumComponent* parenSum (ComponentListIterator& first, ComponentListIterator& last);

      //## Operation: parenList%3DE7AD480002
      std::list<SumComponent*> parenList (int iWord, const ComponentListIterator& first, const ComponentListIterator& last);

      //## Operation: updateExpression%451167440301
      void updateExpression (Component* newComponent, const string& oldName, size_t wordIdx);

      //## Operation: checkCurrentTableModelExpr%4512C27C00CE
      static string checkCurrentTableModelExpr (const Component* component, const string& prevExprString);

      //## Operation: postfixOperatorLocs%48F4F851013B
      std::vector<size_t> postfixOperatorLocs (size_t endIdx, size_t nComps, size_t skipIdx, size_t nSkip) const;

      //## Operation: calcSubgroup%48FF890F02A2
      SumComponent* calcSubgroup (ComponentListIterator begin, ComponentListIterator end, SumComponent* insert = 0, size_t insIdx = 0, size_t nSkip = 0);

    // Additional Private Declarations
      //## begin CGroupBase%3A8C3E710351.private preserve=yes
      //## end CGroupBase%3A8C3E710351.private

  private: //## implementation
    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: index%3A8C42B40266
      int index () const;
      void index (int value);

    // Data Members for Class Attributes

      //## begin CGroupBase::index%3A8C42B40266.attr preserve=no  implementation: int {U} 0
      int m_index;
      //## end CGroupBase::index%3A8C42B40266.attr

      //## Attribute: count%3A8C42C2038D
      //## begin CGroupBase::count%3A8C42C2038D.attr preserve=no  implementation: static int {U} 0
      static int s_count;
      //## end CGroupBase::count%3A8C42C2038D.attr

      //## begin CGroupBase::nested%3AF0551603D5.attr preserve=no  public: bool {U} false
      bool m_nested;
      //## end CGroupBase::nested%3AF0551603D5.attr

      //## begin CGroupBase::componentInfo%484E9B79019B.attr preserve=no  public: ModelExpression<ModExprTreeMember>* {U} 
      ModelExpression<ModExprTreeMember>* m_componentInfo;
      //## end CGroupBase::componentInfo%484E9B79019B.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3A8C40B900BC
      //## begin CGroupBase::groupFlux%3A8C40B9028D.role preserve=no  public: SumComponent { -> 1RFHgN}
      SumComponent* m_groupFlux;
      //## end CGroupBase::groupFlux%3A8C40B9028D.role

      //## Association: XSModel::Model::Component::<unnamed>%3A8D3ED102AA
      //## begin CGroupBase::parent%3A8D3ED6019A.role preserve=no  public: ModelBase { -> 1RHgN}
      ModelBase* m_parent;
      //## end CGroupBase::parent%3A8D3ED6019A.role

      //## Association: XSModel::Model::Component::<unnamed>%3AB668D80201
      //## begin CGroupBase::elements%3AB668D80229.role preserve=no  public: Component { -> 1..nRFHgN}
      ComponentList m_elements;
      //## end CGroupBase::elements%3AB668D80229.role

    // Additional Implementation Declarations
      //## begin CGroupBase%3A8C3E710351.implementation preserve=yes
      //## end CGroupBase%3A8C3E710351.implementation

};

//## begin CGroupBase%3A8C3E710351.postscript preserve=yes
//## end CGroupBase%3A8C3E710351.postscript

// Class CGroupBase 

//## Get and Set Operations for Class Attributes (inline)

inline int CGroupBase::index () const
{
  //## begin CGroupBase::index%3A8C42B40266.get preserve=no
  return m_index;
  //## end CGroupBase::index%3A8C42B40266.get
}

inline void CGroupBase::index (int value)
{
  //## begin CGroupBase::index%3A8C42B40266.set preserve=no
  m_index = value;
  //## end CGroupBase::index%3A8C42B40266.set
}

inline const bool CGroupBase::nested () const
{
  //## begin CGroupBase::nested%3AF0551603D5.get preserve=no
  return m_nested;
  //## end CGroupBase::nested%3AF0551603D5.get
}

inline void CGroupBase::nested (bool value)
{
  //## begin CGroupBase::nested%3AF0551603D5.set preserve=no
  m_nested = value;
  //## end CGroupBase::nested%3AF0551603D5.set
}

inline ModelExpression<ModExprTreeMember>* CGroupBase::componentInfo ()
{
  //## begin CGroupBase::componentInfo%484E9B79019B.get preserve=no
  return m_componentInfo;
  //## end CGroupBase::componentInfo%484E9B79019B.get
}

inline void CGroupBase::componentInfo (ModelExpression<ModExprTreeMember>* value)
{
  //## begin CGroupBase::componentInfo%484E9B79019B.set preserve=no
  m_componentInfo = value;
  //## end CGroupBase::componentInfo%484E9B79019B.set
}

//## Get and Set Operations for Associations (inline)

inline SumComponent* CGroupBase::groupFlux ()
{
  //## begin CGroupBase::groupFlux%3A8C40B9028D.get preserve=no
  return m_groupFlux;
  //## end CGroupBase::groupFlux%3A8C40B9028D.get
}

inline void CGroupBase::groupFlux (SumComponent* value)
{
  //## begin CGroupBase::groupFlux%3A8C40B9028D.set preserve=no
  m_groupFlux = value;
  //## end CGroupBase::groupFlux%3A8C40B9028D.set
}

inline const ModelBase* CGroupBase::parent () const
{
  //## begin CGroupBase::parent%3A8D3ED6019A.get preserve=no
  return m_parent;
  //## end CGroupBase::parent%3A8D3ED6019A.get
}

inline void CGroupBase::parent (ModelBase* value)
{
  //## begin CGroupBase::parent%3A8D3ED6019A.set preserve=no
  m_parent = value;
  //## end CGroupBase::parent%3A8D3ED6019A.set
}

inline const ComponentList& CGroupBase::elements () const
{
  //## begin CGroupBase::elements%3AB668D80229.get preserve=no
  return m_elements;
  //## end CGroupBase::elements%3AB668D80229.get
}

inline void CGroupBase::elements (const ComponentList& value)
{
  //## begin CGroupBase::elements%3AB668D80229.set preserve=no
  m_elements = value;
  //## end CGroupBase::elements%3AB668D80229.set
}

//## begin module%3A8C3FD4030A.epilog preserve=yes
//## end module%3A8C3FD4030A.epilog


#endif
